#ifndef QTS_HTTP_COMM_H
#define QTS_HTTP_COMM_H

/** CQtsHttpServer API success or fail error code. */
typedef enum _QTS_HTTP_API_RESULT_
{
	/** QTS HTTP API success */
	QTS_HTTP_API_SUCCESS = 0,	
	/** QTS HTTP API in progress, return progress rate or total bytes of transferred */
	QTS_HTTP_API_SUCCESS_INPROGRESS = 1,	
	/** QTS HTTP API abort */
	QTS_HTTP_API_SUCCESS_ABORT = 2,							

	/** QTS HTTP API default fail */
	QTS_HTTP_API_FAILURE = 50,			
	/** Network no connection */
	QTS_HTTP_API_FAILURE_NETWORK_NO_CONNECTION = 100,
	/** Network connection failed */
	QTS_HTTP_API_FAILURE_NETWORK_CONNECTION_FAILED = 101,	
	/** Network timeout */
	QTS_HTTP_API_FAILURE_NETWORK_TIMEOUT = 102,				

	/** Parameter invalid */
	QTS_HTTP_API_FAILURE_PARAMETER_INVALID = 200,			

	/** Server disconnect */
	QTS_HTTP_API_FAILURE_SERVER_DISCONNECT = 300,	
	/** Server not exist */
	QTS_HTTP_API_FAILURE_SERVER_NOT_EXIST = 301,			
	/** Not login */
	QTS_HTTP_API_FAILURE_NOT_AUTHORIZED = 400,		
	/** Login fail */
	QTS_HTTP_API_FAILURE_AUTHORIZATION_FAILED = 401,		
	/** No enough memory */
	QTS_HTTP_API_FAILURE_SYSTEM_OUTOFMEMORY = 500,			
	/** Station unsupported */ 
	QTS_HTTP_API_FAILURE_STATION_UNSUPPORTED = 600,	
	/** Station not enabled */
	QTS_HTTP_API_FAILURE_STATION_NOT_ENABLED = 601,			

	/** File exist */
	QTS_HTTP_API_FAILURE_FILE_EXIST = 700,	
	/** File not exist */
	QTS_HTTP_API_FAILURE_FILE_NOT_EXIST = 701,		
	/** File permission denied */
	QTS_HTTP_API_FAILURE_FILE_PERMISSION_DENIED = 702,		
	/** Quota limit exceeded */
	QTS_HTTP_API_FAILURE_FILE_QUOTA_LIMIT_EXCEEDED = 703,
	/** Can't generate upload file */
	QTS_HTTP_API_FAILURE_FILE_CANNOT_GENERATE_CHUNKED_UPLOAD_FILE = 704,
	/** Can't get upload status */
	QTS_HTTP_API_FAILURE_FILE_CANNOT_GET_CHUNKED_UPLOAD_STATUS = 705,
	/** File upload success, but file is broken by some reasons */
	QTS_HTTP_API_FAILURE_FILE_BROKEN = 706,
	/** File write fail */
	QTS_HTTP_API_FAILURE_FILE_WRITE_FAIL = 707,
	/** File invalid file name */
	QTS_HTTP_API_FAILURE_FILE_INVALID_NAME = 708,
}QTS_HTTP_API_RESULT;

#endif	// QTS_HTTP_COMM_H