#pragma once
#include ".\Import\QtsHttp.h"
#include ".\Import\QtsHttpComm.h"
#include ".\Import\QtsHttpFileStation.h"
#include ".\Import\QtsHttpSystem.h"

class QTSHAPIWrapper
{
public:
	QTSHAPIWrapper(void);
	~QTSHAPIWrapper(void);

	void SetServerInfo(CQtsHttpServerInfo serverInfo);
	void SetFSPort(long port);
	void SetFSSSLPort(long SSLport);
    IQtsHttpFileStation* QueryFileStation(){return m_pQTSHTTPFileStation;}

	BOOL GetFileListWithDetailInfo(LPCTSTR strPath, int nStartIdx, int nFileLimit, BOOL* pbCancel, std::vector<CQtsHttpFileStatus>* FileList);
	BOOL UploadFileWithResume(BOOL bResume, LPCTSTR strUploadFileFullPath, LPCTSTR strToFilePath, LPCTSTR strRenameOriDestFileName, BOOL* pbCancel, LPVOID lpData = NULL, PFQTS_HTTP_FILE_STATION_SYNC_PROGRESSBYTES_CALLBACK pfUICallback = NULL);
	BOOL DownloadFileWithResume(BOOL bResume, LPCTSTR strDownloadFileFullPath, LPCTSTR strToFilePath, BOOL* pbCancel, LPVOID lpData = NULL, PFQTS_HTTP_FILE_STATION_SYNC_PROGRESSBYTES_CALLBACK pfHttpFSCallback = NULL);
	BOOL CopyAndRenameFile(LPCTSTR strFromPath, LPCTSTR strToPath, int nMode, LPCTSTR strRenameFilename, BOOL* pbCancel, LPVOID lpData = NULL, PFQTS_HTTP_FILE_STATION_SYNC_PROGRESSRATE_CALLBACK pfHttpFSCallback = NULL);
	BOOL MoveAndRenameFile(LPCTSTR strFromPath, LPCTSTR strToPath, int nMode, LPCTSTR strRenameFilename, BOOL* pbCancel, LPVOID lpData = NULL, PFQTS_HTTP_FILE_STATION_SYNC_PROGRESSRATE_CALLBACK pfHttpFSCallback = NULL);

	IQtsHttpFileStation* OpenFileStation();
	void 	CloseFileStation();

public:
    CQtsHttpServer* m_pQTSHTTPServer;

private:
	long m_FSPort;
	long m_FSSSLPort;
	CQtsHttpServerInfo m_serverInfo;
    IQtsHttpFileStation*   m_pQTSHTTPFileStation;
};

