
// QTSHttpDemoDlg.cpp : implementation file
//
#include "stdafx.h"
#include "QTSHttpDemo.h"
#include "QTSHttpDemoDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static TCHAR *units[] = {_T("B"), _T("KB"), _T("MB"), _T("GB"), _T("TB"), _T("EB"), _T("ZB"), _T("YB")};

BOOL UnicodeToAnsi(LPCTSTR tchStr, char* chRtn, BOOL bTranslatetoUtf8) 
{ 
	int iLen = 0;
	if(tchStr == NULL || chRtn == NULL)
		return FALSE;

	iLen = WideCharToMultiByte(CP_ACP, 0, tchStr, -1, NULL, 0, NULL, NULL); 

	if(iLen > 0)
		WideCharToMultiByte(CP_ACP, 0, tchStr, -1, chRtn , iLen, NULL, NULL);

	return TRUE; 
} 


void FormatSize(long long bytes, int level, int digit, CString& strSize)
{
	double db = (double)bytes;
	CString strFormat;

	while (db > 1024)
	{
		db /= 1024;
		level++;
	}

	if (digit == 0)
	{
		strSize.Format(_T("%d %s"), (int)db, units[level]);
	}
	else if (digit == 1)
	{
		strSize.Format(_T("%.1f %s"), db, units[level]);
	}
	else if (digit == 2)
	{
		strSize.Format(_T("%.2f %s"), db, units[level]);
	}
	else
	{
		if(digit > 0)
		{
			strFormat.Format(_T("%%.%df %%s"), digit);
		}
		else
		{
			strFormat.Format(_T("%%.0f %%s"));
		}

		strSize.Format(strFormat, db, units[level]);
	}
}
// CQTSHttpDemoDlg dialog


HANDLE CQTSHttpDemoDlg::m_hMutex = NULL;

CQTSHttpDemoDlg::CQTSHttpDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CQTSHttpDemoDlg::IDD, pParent)
	, m_strMyQNAPNAS(_T(""))
	, m_strUsername(_T(""))
	, m_strPassword(_T(""))
    , m_Port(0)
    , m_Secure(FALSE)
	, m_llFileSize(0)
{
	m_nFileCount = 0;
	m_dwCopyStart = 0;
	m_bCancel = TRUE;
	m_lpWFMAuth = NULL;
	m_bIsLogin = FALSE;
    m_bMapping = TRUE;
	m_Progress.QuadPart = 0;
    m_hMutex = NULL;
	ZeroMemory(&m_CopyAction, sizeof(COPYFILE_ACTION));
	m_pWaiting = NULL;
    m_QTSHAPIWrapper = NULL;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CQTSHttpDemoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_TXT_USERNAME, m_editUsername);
    DDX_Text(pDX, IDC_TXT_USERNAME, m_strUsername);
    DDX_Control(pDX, IDC_TXT_PASSWORD, m_editPassword);
    DDX_Text(pDX, IDC_TXT_PASSWORD, m_strPassword);
    DDX_Control(pDX, IDC_BTN_LOGIN, m_btnLogin);
    DDX_Control(pDX, IDC_BTN_UPLOAD, m_btnUpload);
    DDX_Control(pDX, IDC_BTN_DOWNLOAD, m_btnDownload);
    DDX_Control(pDX, IDC_TXT_PROGRESS, m_txtProgress);
    DDX_Control(pDX, IDC_COPYPROGRESS, m_cCopyProgressbar);
    DDX_Control(pDX, IDC_LOCAL_TREE, m_LocalTreeCtrl);
    DDX_Control(pDX, IDC_LOCAL_LIST, m_LocalListCtrl);
    DDX_Control(pDX, IDC_REMOTE_TREE, m_RemoteTreeCtrl);
    DDX_Control(pDX, IDC_REMOTE_LIST, m_RemoteListCtrl);
    DDX_Control(pDX, IDC_IPADDRESS1, m_IPAddress);
    DDX_Text(pDX, IDC_PORT, m_Port);
    DDX_Check(pDX, IDC_SECURE, m_Secure);
}

BEGIN_MESSAGE_MAP(CQTSHttpDemoDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_LOGIN, &CQTSHttpDemoDlg::OnBnClickedLogin)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_UPLOAD, &CQTSHttpDemoDlg::OnBnClickedBtnUpload)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_DOWNLOAD, &CQTSHttpDemoDlg::OnBnClickedBtnDownload)
	ON_NOTIFY(TVN_SELCHANGED, IDC_LOCAL_TREE, &CQTSHttpDemoDlg::OnSelchangedLocalTree)
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_LOCAL_TREE, &CQTSHttpDemoDlg::OnItemexpandingLocalTree)
	ON_NOTIFY(NM_DBLCLK, IDC_LOCAL_TREE, &CQTSHttpDemoDlg::OnDblclkLocalTree)
	ON_NOTIFY(NM_DBLCLK, IDC_LOCAL_LIST, &CQTSHttpDemoDlg::OnDblclkLocalList)
	ON_NOTIFY(TVN_SELCHANGED, IDC_REMOTE_TREE, &CQTSHttpDemoDlg::OnSelchangedRemoteTree)
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_REMOTE_TREE, &CQTSHttpDemoDlg::OnItemexpandingRemoteTree)
	ON_NOTIFY(NM_DBLCLK, IDC_REMOTE_TREE, &CQTSHttpDemoDlg::OnDblclkRemoteTree)
	ON_NOTIFY(NM_DBLCLK, IDC_REMOTE_LIST, &CQTSHttpDemoDlg::OnDblclkRemoteList)
END_MESSAGE_MAP()


// CQTSHttpDemoDlg message handlers

BOOL CQTSHttpDemoDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    m_strMyQNAPNAS = _T("QNAP NAS");
#ifdef DEBUG
    m_IPAddress.SetAddress(192,168,68,47);
	m_strUsername = _T("admin");
	m_strPassword = _T("admin");
#endif 
	m_Port = 8080;
    m_Secure = FALSE;
	UpdateData(FALSE);
	m_cCopyProgressbar.SetRange(0, 100);

	CTime ctToday = CTime::GetCurrentTime();
	m_strLogFilename.Format(_T("QTSHTTPSDKDEMO_%s.log"), ctToday.Format(_T("%Y%m%d")));
	
	HICON hIcon = NULL;
    // Create mutex
    m_hMutex = CreateMutex(NULL, FALSE, NULL);

	CWinApp *pApp = AfxGetApp();
	if(pApp)
	{
		m_ImageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 9, 9);
		m_ImageList.Add(pApp->LoadIcon(IDI_ICON_COMPUTER));
		m_ImageList.Add(pApp->LoadIcon(IDI_ICON_HDD));
		m_ImageList.Add(pApp->LoadIcon(IDI_ICON_FOLDER));
		m_ImageList.Add(pApp->LoadIcon(IDI_ICON_FILE));
	}
	m_LocalTreeCtrl.SetImageList(&m_ImageList, LVSIL_NORMAL);
	m_LocalListCtrl.SetImageList(&m_ImageList, LVSIL_SMALL);
	m_RemoteTreeCtrl.SetImageList(&m_ImageList, LVSIL_NORMAL);
	m_RemoteListCtrl.SetImageList(&m_ImageList, LVSIL_SMALL);

	m_LocalListCtrl.InsertColumn(0, _T("File Name"), LVCFMT_LEFT, 250);
	m_RemoteListCtrl.InsertColumn(0, _T("File Name"), LVCFMT_LEFT, 250);

	HTREEITEM root = m_LocalTreeCtrl.InsertItem(_T("MyComputer"), 0);

	CString label;
	wchar_t drive[512] = _T("A:"); 
	unsigned int drives = GetLogicalDrives(); 
	while(drives) 
	{ 
		if((drives & 1) )
		{ 
			label.Format(_T("%s"), drive);
			FILE_INFO* fi = new FILE_INFO;
			_tcscpy_s(fi->strFileName, label);
			fi->bFolder = TRUE;
			HTREEITEM itm = m_LocalTreeCtrl.InsertItem(label, 1, 1, root);
			m_LocalTreeCtrl.SetItemData(itm, (DWORD_PTR)fi);
		} 
		drive[0]++; drives >>= 1;
	}
	m_LocalTreeCtrl.Expand(root, TVE_EXPAND);

    m_QTSHAPIWrapper = new QTSHAPIWrapper();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CQTSHttpDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CQTSHttpDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CQTSHttpDemoDlg::AddLog(LOGCATEGORY category, CString LogContent1, CString LogContent2, CString LogContent3)
{
	if (!m_bCanAddLog) return;

	CString LogString;
	CTime ctNow = CTime::GetCurrentTime();
	switch (category)
	{
	case LOGIN_START:
		LogString.Format(_T("[LOGIN] Login <%s> to %s"), LogContent1, LogContent2);
		break;
	case LOGIN:
		LogString.Format(_T("[LOGIN] %s"), LogContent1);
		break;
	case LOGOUT_START:
		LogString.Format(_T("[LOGOUT] <%s> has logout from %s"), LogContent1, LogContent2);
		break;
	case LOGOUT:
		LogString.Format(_T("[LOGOUT] %s"), LogContent1);
		break;
	case COPYFILE_START:
		LogString.Format(_T("[COPYFILE] Start to %s, From %s to %s"), LogContent1, LogContent2, LogContent3);
		break;
	case COPYFILE:
		LogString.Format(_T("[COPYFILE] Copy %s(%s), average speed %s/sec"), LogContent1, LogContent2, LogContent3);
		break;
	case COPYFILE_FAIL:
		LogString.Format(_T("[COPYFILE] Fail to %s %s, %s"), LogContent1, LogContent2, LogContent3);
		break;
	case COPYFILE_DONE:
		LogString.Format(_T("[COPYFILE] %s Completed, take %s seconds, average speed %s/sec"), LogContent1, LogContent2, LogContent3);
		break;
	}

	CString LogContent;
	LogContent.Format(_T("[%s]\t%s\r\n"), ctNow.Format(_T("%H:%M:%S")), LogString);
	m_fLogFile.Write(LogContent, LogContent.GetLength() * sizeof(TCHAR));
	m_fLogFile.Flush();
}

void CQTSHttpDemoDlg::Login()
{
    BYTE IPAddress[4];
    m_IPAddress.GetAddress(IPAddress[0], IPAddress[1], IPAddress[2], IPAddress[3]);
    CString strIPAddress;
    strIPAddress.Format(_T("%d.%d.%d.%d"), IPAddress[0], IPAddress[1], IPAddress[2], IPAddress[3]);

	if (strIPAddress.GetLength() > 0 && m_strUsername.GetLength() > 0 && m_strPassword.GetLength() > 0)
	{
		AddLog(LOGIN_START, m_strUsername, strIPAddress);

        std::wstring IP = strIPAddress.GetString();
        std::wstring UserName = m_strUsername.GetString();
        std::wstring Password = m_strPassword.GetString();
        if (m_QTSHAPIWrapper)
        {
			CQtsHttpServerInfo serverInfo(IP.c_str(), UserName.c_str(), Password.c_str(), m_Secure, L"");
			if (m_Secure)
				m_QTSHAPIWrapper->SetFSSSLPort(m_Port);
			else
				m_QTSHAPIWrapper->SetFSPort(m_Port);
			m_QTSHAPIWrapper->SetServerInfo(serverInfo);
			IQtsHttpFileStation* pQTSHTTPFileStation = m_QTSHAPIWrapper->OpenFileStation();
			if (pQTSHTTPFileStation)
				m_bIsLogin = TRUE;
			else
			{
				m_QTSHAPIWrapper->CloseFileStation();
				m_bIsLogin = FALSE;
			}
        }
	}

    if (m_pWaiting) 
        m_pWaiting->PostMessage(WM_ENDDIALOG, 0, 0);
}

void CQTSHttpDemoDlg::Logout()
{
    BYTE IPAddress[4];
    m_IPAddress.GetAddress(IPAddress[0], IPAddress[1], IPAddress[2], IPAddress[3]);
    CString strIPAddress;
    strIPAddress.Format(_T("%d.%d.%d.%d"), IPAddress[0], IPAddress[1], IPAddress[2], IPAddress[3]);

	AddLog(LOGOUT_START, m_strUsername, strIPAddress);

    if (m_QTSHAPIWrapper)
    {
		m_QTSHAPIWrapper->CloseFileStation();
    }
	
	m_bIsLogin = FALSE;

    if (m_pWaiting) 
        m_pWaiting->PostMessage(WM_ENDDIALOG, 0, 0);
}

void CQTSHttpDemoDlg::Lock()
{
    if(m_hMutex)
    {
        ::WaitForSingleObject(m_hMutex, INFINITE);
    }
}

void CQTSHttpDemoDlg::Unlock()
{
    if(m_hMutex)
    {
        ::ReleaseMutex(m_hMutex);
    }
}

void CQTSHttpDemoDlg::OnBnClickedLogin()
{
	UpdateData(TRUE);

	CFileException e;
	m_bCanAddLog = TRUE;
	if (!m_fLogFile.Open(m_strLogFilename, CFile::modeCreate|CFile::modeNoTruncate|CFile::modeRead|CFile::modeWrite, &e))
	{
		m_bCanAddLog = FALSE;
	}

	LONGLONG pos = m_fLogFile.SeekToEnd();
	m_fLogFile.SetLength(pos);

	m_btnLogin.EnableWindow(FALSE);

	if (!m_bIsLogin)
	{
		m_pThread = ::AfxBeginThread(LoginProc, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);	
		if(m_pThread) 
		{
			m_pThread->m_bAutoDelete = TRUE;
			m_pThread->ResumeThread();

			m_pWaiting = new CWaitDlg(this);
			if (m_pWaiting)
			{
				m_pWaiting->DoModal();
				delete m_pWaiting;
				m_pWaiting = NULL;
			}

			if (!m_bIsLogin)
			{
				AfxMessageBox(_T("Login failure! Please check if connection information is correctly."));
			}
		}
	}
	else
    {
        m_pThread = ::AfxBeginThread(LogoutProc, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);	
        if(m_pThread) 
        {
            m_pThread->m_bAutoDelete = TRUE;
            m_pThread->ResumeThread();

            m_pWaiting = new CWaitDlg(this);
            if (m_pWaiting)
            {
                m_pWaiting->DoModal();
                delete m_pWaiting;
                m_pWaiting = NULL;
            }
        }
    }

	m_bCanAddLog = FALSE;
	m_fLogFile.Close();		
	
    if (m_bIsLogin)
    {
        m_btnLogin.SetWindowText(_T("Logout"));

        BuildRemoteShareFolder();
    }
    else
    {
        m_btnLogin.SetWindowText(_T("Login"));

        int count = m_RemoteListCtrl.GetItemCount();
        for (int i=0; i<count; i++)
        {
            FILE_INFO* p = (FILE_INFO*)m_RemoteListCtrl.GetItemData(i);
            delete p;
        }
        m_RemoteListCtrl.DeleteAllItems();
        DestroyTree(m_RemoteTreeCtrl, m_RemoteTreeCtrl.GetRootItem());
        m_RemoteTreeCtrl.DeleteAllItems();
    }

	m_btnLogin.EnableWindow(TRUE);

	m_btnUpload.EnableWindow(m_bIsLogin);
	m_btnDownload.EnableWindow(m_bIsLogin);
	m_editUsername.SetReadOnly(m_bIsLogin);
	m_editPassword.SetReadOnly(m_bIsLogin);
}

void CQTSHttpDemoDlg::DestroyTree(CTreeCtrl& tree, HTREEITEM item)
{
	if (!item) return;

	HTREEITEM subItem = NULL;

	if (tree.ItemHasChildren(item))
	{
		subItem = tree.GetChildItem(item);
		DestroyTree(tree, subItem);
		
		subItem = tree.GetNextSiblingItem(subItem);
		while(subItem)
		{
			DestroyTree(tree, subItem);
			
			subItem = tree.GetNextSiblingItem(subItem);
		}
	}
	
	FILE_INFO* p = (FILE_INFO*)tree.GetItemData(item);
	delete p;
}

void CQTSHttpDemoDlg::OnDestroy()
{
    // Close mutex
    if(m_hMutex)
    {
        CloseHandle(m_hMutex);
        m_hMutex = NULL;
    }

	if (m_pWaiting) 
	{
		m_pWaiting->DestroyWindow();
		delete m_pWaiting;
		m_pWaiting = NULL;
	}

	int count;
	count = m_LocalListCtrl.GetItemCount();
	for (int i=0; i<count; i++)
	{
		FILE_INFO* p = (FILE_INFO*)m_LocalListCtrl.GetItemData(i);
		delete p;
	}
	m_LocalListCtrl.DeleteAllItems();
	DestroyTree(m_LocalTreeCtrl, m_LocalTreeCtrl.GetRootItem());

	count = m_RemoteListCtrl.GetItemCount();
	for (int i=0; i<count; i++)
	{
		FILE_INFO* p = (FILE_INFO*)m_RemoteListCtrl.GetItemData(i);
		delete p;
	}
	m_RemoteListCtrl.DeleteAllItems();
	DestroyTree(m_RemoteTreeCtrl, m_RemoteTreeCtrl.GetRootItem());

    if (m_QTSHAPIWrapper != NULL)
    {
        delete m_QTSHAPIWrapper;
        m_QTSHAPIWrapper = NULL;
    }

	CDialogEx::OnDestroy();	
}

UINT CQTSHttpDemoDlg::LoginProc(IN LPVOID lpContext)
{
	CQTSHttpDemoDlg* pThis = (CQTSHttpDemoDlg*)lpContext;
	pThis->Login();

	return 0;
}

UINT CQTSHttpDemoDlg::LogoutProc(IN LPVOID lpContext)
{
    CQTSHttpDemoDlg* pThis = (CQTSHttpDemoDlg*)lpContext;
    pThis->Logout();

    return 0;
}


UINT CQTSHttpDemoDlg::CopyFileProc(IN LPVOID lpContext)
{
	CQTSHttpDemoDlg* pThis = (CQTSHttpDemoDlg*)lpContext;
	if (pThis->m_CopyAction.nAction == ACTION_UPLOAD)
		pThis->UploadFile(&(pThis->m_bCancel));
	else
		pThis->DownloadFile(&(pThis->m_bCancel));

	return 0;
}

void CQTSHttpDemoDlg::UploadFile(BOOL* pbCancel)
{	
	//CString strSrcPath = _T("D:\\testupload.sdf"), strDestPath = _T("/Public/"), strTemp = _T("");
	CFileException e;
	m_bCanAddLog = TRUE;
 	if (!m_fLogFile.Open(m_strLogFilename, CFile::modeCreate| CFile::modeNoTruncate |CFile::modeWrite| CFile::modeRead, &e))
	{
		m_bCanAddLog = FALSE;
	}		
	
	LONGLONG pos = m_fLogFile.SeekToEnd();
	m_fLogFile.SetLength(pos);

	m_dwCopyStart = GetTickCount();

	AddLog(COPYFILE_START, _T("Upload"), m_CopyAction.LocalFile, m_CopyAction.RemoteFile);


    if (m_QTSHAPIWrapper)
    {
        IQtsHttpFileStation* pQTSHTTPFileStation = m_QTSHAPIWrapper->QueryFileStation();
        if (pQTSHTTPFileStation)
        {
            std::wstring RemoteFile = m_CopyAction.RemoteFile;
            if (!RemoteFile.empty())
            {
				//BOOL bCancel = FALSE;
				CQtsHttpFileEntry UploadFileEntry;
				std::wstring FilePath = m_CopyAction.LocalFile; 
				std::wstring toFilePath = m_CopyAction.RemoteFile;
				std::wstring::size_type found = RemoteFile.find_last_of(L"/\\");
				std::wstring FolderPath = RemoteFile.substr(0,found);
				std::wstring FileName = RemoteFile.substr(found+1);
				UploadFileEntry.SetFilePath(FolderPath.c_str());
				UploadFileEntry.SetFileName(FileName.c_str());

				HANDLE hFile = ::CreateFile(FilePath.c_str(), 
					GENERIC_WRITE, 
					FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, 
					NULL, 
					OPEN_ALWAYS,
					FILE_ATTRIBUTE_TEMPORARY | FILE_FLAG_BACKUP_SEMANTICS, 
					NULL);
				LARGE_INTEGER FileStartPosition = {0};
				::GetFileSizeEx(hFile, &FileStartPosition);
				m_llFileSize = FileStartPosition.QuadPart;
				if(hFile)
				{
					CloseHandle(hFile);
					hFile = NULL;
				}
				PFQTS_HTTP_FILE_STATION_SYNC_PROGRESSBYTES_CALLBACK pfHttpFSCallback = &CQTSHttpDemoDlg::copy_file_progress_callback;
				pQTSHTTPFileStation->UploadFileByPath(FilePath.c_str(), toFilePath.c_str(), pbCancel, (LPVOID)this, pfHttpFSCallback);

				//Test data
				//m_QTSHAPIWrapper->UploadFileWithResume(TRUE, FilePath.c_str(), toFilePath.c_str(), L"vincent", &bCancel, (LPVOID)this, pfHttpFSCallback);
            }
        }
    }

	m_bCanAddLog = FALSE;
	m_fLogFile.Close();		

	CopyFileCompleted();
}

void CQTSHttpDemoDlg::DownloadFile(BOOL* pbCancel)
{	
	CFileException e;
	m_bCanAddLog = TRUE;
	if (!m_fLogFile.Open(m_strLogFilename, CFile::modeCreate| CFile::modeNoTruncate |CFile::modeWrite| CFile::modeRead, &e))
	{
		m_bCanAddLog = FALSE;
	}
	
	m_dwCopyStart = GetTickCount();
	AddLog(COPYFILE_START, _T("Download"), m_CopyAction.RemoteFile, m_CopyAction.LocalFile);

	// Test data
	//std::vector <CQtsHttpFileStatus> t_vFileDetail;
	//m_QTSHAPIWrapper->GetFileListWithDetailInfo(L"/Public", 0, 20, pbCancel, &t_vFileDetail);

    if (m_QTSHAPIWrapper)
    {
        IQtsHttpFileStation* pQTSHTTPFileStation = m_QTSHAPIWrapper->QueryFileStation();
        if (pQTSHTTPFileStation)
        {
            std::wstring RemoteFile = m_CopyAction.RemoteFile;
            CQtsHttpFileStatus FileEntry;
			BOOL bFileStatusCancel = FALSE;

			
			if (pQTSHTTPFileStation->GetFileStatus(RemoteFile.c_str(), &bFileStatusCancel, FileEntry) == QTS_HTTP_API_SUCCESS && FileEntry.IsDir() == FALSE)
			{
				std::wstring toFilePath = m_CopyAction.LocalFile;
				m_llFileSize = FileEntry.GetFileSize();
				PFQTS_HTTP_FILE_STATION_SYNC_PROGRESSBYTES_CALLBACK pfHttpFSCallback = &CQTSHttpDemoDlg::copy_file_progress_callback;
				if (QTS_HTTP_API_SUCCESS == pQTSHTTPFileStation->DownloadFileByPath( RemoteFile.c_str(),
																						toFilePath.c_str(),
																						0,
																						pbCancel,
																						(LPVOID)this,
																						pfHttpFSCallback))
				//Test data
				//if (TRUE == m_QTSHAPIWrapper->DownloadFileWithResume(TRUE, RemoteFile.c_str(), toFilePath.c_str(), pbCancel, (LPVOID) this, pfHttpFSCallback))
				//if (TRUE == m_QTSHAPIWrapper->CopyAndRenameFile(L"/Public/a.rtf", L"/Public/tmp", 1, L"vincent.rtf", pbCancel, NULL, NULL))
				{
					m_Progress.QuadPart = 100;
				}
			}
        }
    }

	m_bCanAddLog = FALSE;
	m_fLogFile.Close();		

	CopyFileCompleted();
}

void CQTSHttpDemoDlg::OnStartCopyFile(int nAction, CString LocalFile, CString RemoteFile)
{
	m_CopyAction.nAction = nAction;
	_tcscpy_s(m_CopyAction.LocalFile, LocalFile);
	_tcscpy_s(m_CopyAction.RemoteFile, RemoteFile);

	int nProc = 0;
	CString tmp;
	tmp.Format(_T("%d %%  "), nProc);
	m_cCopyProgressbar.SetPos(nProc);
	m_txtProgress.SetWindowText(tmp);

	m_pThread = ::AfxBeginThread(CopyFileProc, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);	
	if(m_pThread) 
	{
		m_pThread->m_bAutoDelete = TRUE;
		m_pThread->ResumeThread();

		SetTimer(UPDATE_PROGRESS, 1000, NULL);
	}

	m_cCopyProgressbar.ShowWindow(TRUE);
	m_txtProgress.ShowWindow(TRUE);
}

void CQTSHttpDemoDlg::OnBnClickedBtnUpload()
{
	if (m_LocalListCtrl.GetSelectedCount() == 0)
	{
		AfxMessageBox(_T("There is no file was selected for uploading!"));
		return;
	}

	if (m_RemoteTreeCtrl.GetSelectedCount() == 0 || m_RemoteTreeCtrl.GetSelectedItem() == m_RemoteTreeCtrl.GetRootItem())
	{
		AfxMessageBox(_T("You need to select a remote folder to save uploaded file."));
		return;
	}

	POSITION pos = m_LocalListCtrl.GetFirstSelectedItemPosition();
	if(pos)
	{
		int nIdx = m_LocalListCtrl.GetNextSelectedItem(pos);
		if(nIdx != -1)
		{
			m_bCancel = !m_bCancel;

			if (m_bCancel)
			{
				m_btnUpload.SetWindowText(_T("Upload"));
				m_btnLogin.EnableWindow(TRUE);
				m_btnDownload.EnableWindow(TRUE);
			}
			else
			{
				CString strSrcPath = _T("D:\\testupload.sdf"), strDestPath = _T("/Public/");

				FILE_INFO* fi = (FILE_INFO*)m_LocalListCtrl.GetItemData(nIdx);
				if (fi->bFolder)
				{
					AfxMessageBox(_T("You need to select a file to upload, NOT FOLDER."));
					return;
				}

				strSrcPath.Format(_T("%s"), fi->strFileName);

				int nPos = strSrcPath.ReverseFind(_T('\\'));
				CString strCom = _T("");
				if(nPos != -1)
				{
					strCom += strSrcPath.Mid(nPos+1, strSrcPath.GetLength()-nPos);
				}

				HTREEITEM hitem = m_RemoteTreeCtrl.GetSelectedItem();
				fi = (FILE_INFO*)m_RemoteTreeCtrl.GetItemData(hitem);
				strDestPath.Format(_T("%s/"), fi->strFileName);

				int count;
				BOOL bFind = FALSE;
				count = m_RemoteListCtrl.GetItemCount();
				for (int i=0; i<count; i++)
				{
					FILE_INFO* p = (FILE_INFO*)m_RemoteListCtrl.GetItemData(i);
					CString strNAS = _T("");
					CString strNASCom = _T("");
					strNAS.Format(_T("%s"), p->strFileName);
					int nPos = strNAS.ReverseFind(_T('/'));
					
					if(nPos != -1)
					{
						strNASCom = strNAS.Mid(nPos+1, strNAS.GetLength()-nPos);
					}
					if (strCom.Compare(strNASCom) == 0)
						bFind = TRUE;
				}

				if (bFind)
				{
					int select = MessageBox( L"File exist! Do you continue upload file?",
						L"QNAP C++ SDK sample",
						MB_YESNO | MB_ICONQUESTION);

					if (select == IDYES)
					{
						OnStartCopyFile(ACTION_UPLOAD, strSrcPath, strDestPath);
						m_btnUpload.SetWindowText(_T("Cancel"));
						m_btnLogin.EnableWindow(FALSE);
						m_btnDownload.EnableWindow(FALSE);
					}
					else
						m_bCancel = !m_bCancel;
				}
				else
				{
					OnStartCopyFile(ACTION_UPLOAD, strSrcPath, strDestPath);
					m_btnUpload.SetWindowText(_T("Cancel"));
					m_btnLogin.EnableWindow(FALSE);
					m_btnDownload.EnableWindow(FALSE);
				}
			}
		}
	}
}

void CQTSHttpDemoDlg::OnBnClickedBtnDownload()
{
	if (m_RemoteListCtrl.GetSelectedCount() == 0)
	{
		AfxMessageBox(_T("There is no file was selected to download!"));
		return;
	}

	if (m_LocalTreeCtrl.GetSelectedCount() == 0 || m_LocalTreeCtrl.GetSelectedItem() == m_LocalTreeCtrl.GetRootItem())
	{
		AfxMessageBox(_T("You need to select a Local folder to save downloaded file."));
		return;
	}

	POSITION pos = m_RemoteListCtrl.GetFirstSelectedItemPosition();
	if(pos)
	{
		int nIdx = m_RemoteListCtrl.GetNextSelectedItem(pos);
		if(nIdx != -1)
		{
			m_bCancel = !m_bCancel;

			if (m_bCancel)
			{
				m_btnUpload.SetWindowText(_T("Upload"));
				m_btnLogin.EnableWindow(TRUE);
				m_btnDownload.EnableWindow(TRUE);
			}
			else
			{
				CString strSrcPath = _T("D:\\ISO\\"), strDestPath = _T("/Public/testupload.sdf");

				FILE_INFO* fi = (FILE_INFO*)m_RemoteListCtrl.GetItemData(nIdx);
				if (fi->bFolder)
				{
					AfxMessageBox(_T("You need to select a file to download, NOT FOLDER."));
					return;
				}

				strSrcPath.Format(_T("/%s"), fi->strFileName);

				HTREEITEM hitem = m_LocalTreeCtrl.GetSelectedItem();
				fi = (FILE_INFO*)m_LocalTreeCtrl.GetItemData(hitem);
				strDestPath.Format(_T("%s\\"), fi->strFileName);

				int nPos = strSrcPath.ReverseFind(_T('/'));
				if(nPos != -1)
				{
					strDestPath += strSrcPath.Mid(nPos+1, strSrcPath.GetLength()-nPos);
				}

				int count;
				BOOL bFind = FALSE;
				count = m_LocalListCtrl.GetItemCount();
				for (int i=0; i<count; i++)
				{
					FILE_INFO* p = (FILE_INFO*)m_LocalListCtrl.GetItemData(i);
					if (strDestPath.Compare(p->strFileName) == 0)
						bFind = TRUE;
				}

				if (bFind)
				{
					int select = MessageBox( L"File exist! Do you continue download file?",
						L"QNAP C++ SDK sample",
						MB_YESNO | MB_ICONQUESTION);

					if (select == IDYES)
					{
						OnStartCopyFile(ACTION_DOWNLOAD, strDestPath, strSrcPath);
						m_btnDownload.SetWindowText(_T("Cancel"));
						m_btnLogin.EnableWindow(FALSE);
						m_btnUpload.EnableWindow(FALSE);
					}
					else
						m_bCancel = !m_bCancel;
				}
				else
				{
					OnStartCopyFile(ACTION_DOWNLOAD, strDestPath, strSrcPath);
					m_btnDownload.SetWindowText(_T("Cancel"));
					m_btnLogin.EnableWindow(FALSE);
					m_btnUpload.EnableWindow(FALSE);
				}
			}
		}
	}
}

void CQTSHttpDemoDlg::copy_file_progress_callback(LPVOID owner, LONGLONG llTotalBytesTransferred)
{
    CQTSHttpDemoDlg* pThis = (CQTSHttpDemoDlg*)owner;
    if (pThis)
    {
		int t_nProgressRate = ((llTotalBytesTransferred*1.0)/pThis->m_llFileSize)*100;
        pThis->SetProgress(t_nProgressRate);
    }

	return;
}

void CQTSHttpDemoDlg::CopyFileCompleted()
{
	m_bCancel = TRUE;
	m_btnUpload.SetWindowText(_T("Upload"));
	m_btnDownload.SetWindowText(_T("Download"));
	m_btnLogin.EnableWindow(TRUE);
	m_btnUpload.EnableWindow(TRUE);
	m_btnDownload.EnableWindow(TRUE);

}

void CQTSHttpDemoDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == UPDATE_PROGRESS)
	{
		if (m_Progress.QuadPart > 0)
		{
			int nProc = m_Progress.QuadPart;
            CString tmp;
            tmp.Format(_T("%d %%  "), nProc);
			m_cCopyProgressbar.SetPos(nProc);
            m_txtProgress.SetWindowText(tmp);

 			if (nProc == 100)
 				KillTimer(UPDATE_PROGRESS);
		}
	}

	CDialogEx::OnTimer(nIDEvent);
}

void CQTSHttpDemoDlg::LoadLocalFileList(CString strPath)
{
	CString SearchPattern;
	SearchPattern = strPath + _T("*");

    int count;
    count = m_LocalListCtrl.GetItemCount();
    for (int i=0; i<count; i++)
    {
        FILE_INFO* p = (FILE_INFO*)m_LocalListCtrl.GetItemData(i);
        delete p;
    }
    m_LocalListCtrl.DeleteAllItems();

	CFileFind finder;
    BOOL bFound = finder.FindFile(SearchPattern);
    if (bFound)
    {
        int nIndex = 0;
        while (bFound)
        {
            bFound = finder.FindNextFile();
            // skip . and .. files; otherwise, we'd
            // recur infinitely!
            if (finder.IsDots())
                continue;

			FILE_INFO* fi = new FILE_INFO;
			_tcscpy_s(fi->strFileName, finder.GetFilePath());
			fi->bFolder = finder.IsDirectory();
			int ImgIdx = fi->bFolder? 2: 3;
			m_LocalListCtrl.InsertItem(nIndex, finder.GetFileName(), ImgIdx);
			m_LocalListCtrl.SetItemData(nIndex, (DWORD_PTR)fi);
			nIndex++;
		}

		finder.Close();
	}
}

void CQTSHttpDemoDlg::BuildRemoteShareFolder()
{
    std::vector<CQtsHttpFileEntry> vFolderList;
	BOOL bCancel = FALSE;
    if (m_QTSHAPIWrapper)
    {
        IQtsHttpFileStation* pQTSHTTPFileStation = m_QTSHAPIWrapper->QueryFileStation();
        if (pQTSHTTPFileStation)
        {
            pQTSHTTPFileStation->GetShareFolderList(&bCancel, &vFolderList);
        }
    }

	HTREEITEM root = m_RemoteTreeCtrl.InsertItem(m_strMyQNAPNAS, 0);
    for(size_t i = 0; i < vFolderList.size(); i++)
    {
        FILE_INFO* fi = new FILE_INFO;

        _tcscpy_s(fi->strFileName, vFolderList[i].GetFileName());

        fi->bFolder = vFolderList[i].IsDir();
        HTREEITEM itm = m_RemoteTreeCtrl.InsertItem(vFolderList[i].GetFileName(), 2, 2, root);
        m_RemoteTreeCtrl.SetItemData(itm, (DWORD_PTR)fi);
    }
	m_RemoteTreeCtrl.Expand(root, TVE_EXPAND);
}

void CQTSHttpDemoDlg::BuildRemoteSubTree(HTREEITEM hItem, LPCTSTR Node)
{
    std::vector<CQtsHttpFileEntry> vFolderList;
	BOOL bCancel = FALSE;
	BOOL bFileListCancel = FALSE;
    if (m_QTSHAPIWrapper)
    {
        IQtsHttpFileStation* pQTSHTTPFileStation = m_QTSHAPIWrapper->QueryFileStation();
        if (pQTSHTTPFileStation)
        {
			int t_nFileCount = 0;
			pQTSHTTPFileStation->GetFileListCount(Node, &bCancel, t_nFileCount);
            pQTSHTTPFileStation->GetFileList(Node, 0, t_nFileCount, &bFileListCancel, &vFolderList);
        }
    }

    for(size_t i = 0; i < vFolderList.size(); i++)
    {
		if (vFolderList[i].IsDir())
		{
			FILE_INFO* fi = new FILE_INFO;
			CString FullName;
			FullName.Format(_T("%s/%s"), Node, vFolderList.data()[i].GetFileName());
			_tcscpy_s(fi->strFileName, FullName);
			fi->bFolder = vFolderList[i].IsDir();
			HTREEITEM itm = m_RemoteTreeCtrl.InsertItem(vFolderList.data()[i].GetFileName(), 2, 2, hItem);
			m_RemoteTreeCtrl.SetItemData(itm, (DWORD_PTR)fi);
		}
    }
}

void CQTSHttpDemoDlg::LoadRemoteFileList(CString strPath)
{
    if (!m_bIsLogin) return;

    int count = m_RemoteListCtrl.GetItemCount();
	for (int i=0; i<count; i++)
	{
		FILE_INFO* p = (FILE_INFO*)m_RemoteListCtrl.GetItemData(i);
		delete p;
	}
    m_RemoteListCtrl.DeleteAllItems();

    int nStartIndex = 0;
    int nLimit = 20;
    int nTotalFileCount = 0;
    std::vector<CQtsHttpFileEntry> vFileList;
	std::vector<CQtsHttpFileEntry> tvFileList;
	BOOL bFileListCountCancel = FALSE;
	BOOL bFileListCancel = FALSE;
	std::wstring IMGURL;
    if (m_QTSHAPIWrapper)
    {
        IQtsHttpFileStation* pQTSHTTPFileStation = m_QTSHAPIWrapper->QueryFileStation();
        if (pQTSHTTPFileStation)
		{
			pQTSHTTPFileStation->GetFileListCount(strPath.GetString(), &bFileListCountCancel, nTotalFileCount);
            do {
                if (QTS_HTTP_API_SUCCESS == pQTSHTTPFileStation->GetFileList(strPath.GetString(), nStartIndex, nLimit, &bFileListCancel, &tvFileList))
                {
                    nStartIndex += nLimit;
                }
                else
                {
                    break;
				}
            } while (nStartIndex < nTotalFileCount && tvFileList.size() < nTotalFileCount);\
			for(int i = 0; i < tvFileList.size(); i++)
				vFileList.push_back(tvFileList[i]);
		}
	}

    for(size_t i = 0; i < vFileList.size(); i++)
    {
     	FILE_INFO* fi = new FILE_INFO;
     	CString FullName;
     
     	FullName.Format(_T("%s/%s"), strPath, vFileList[i].GetFileName());
     	_tcscpy_s(fi->strFileName, FullName);
     	fi->bFolder = vFileList[i].IsDir();
     
     	int ImgIdx = fi->bFolder? 2: 3;
     	m_RemoteListCtrl.InsertItem(i, vFileList[i].GetFileName(), ImgIdx);
     	m_RemoteListCtrl.SetItemData(i, (DWORD_PTR)fi);
    }
}

void CQTSHttpDemoDlg::OnDblclkLocalList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	FILE_INFO* fi = (FILE_INFO*)m_LocalListCtrl.GetItemData(pNMItemActivate->iItem);
	if (fi->bFolder)
	{
		//m_LocalListCtrl.DeleteAllItems();

		CString CurrentPath;
		CurrentPath.Format(_T("%s\\"), fi->strFileName);
		LoadLocalFileList(CurrentPath);
	}

	*pResult = 0;
}

void CQTSHttpDemoDlg::OnSelchangedLocalTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	
	HTREEITEM hItem = pNMTreeView->itemNew.hItem;//m_LocalTreeCtrl.GetSelectedItem();
	
	if (hItem != m_LocalTreeCtrl.GetRootItem())
	{
		FILE_INFO* fi = (FILE_INFO*)m_LocalTreeCtrl.GetItemData(hItem);
		CString SearchPattern;
		SearchPattern.Format(_T("%s\\"), fi->strFileName);
		LoadLocalFileList(SearchPattern);
	}
	else if (pNMTreeView->itemOld.hItem && pNMTreeView->itemOld.hItem != m_LocalTreeCtrl.GetRootItem())
	{
		m_LocalTreeCtrl.SelectItem(pNMTreeView->itemOld.hItem);
	}

	*pResult = 0;
}

void CQTSHttpDemoDlg::ExpandLocalTreeItem(HTREEITEM hItem)
{
	if (!m_LocalTreeCtrl.ItemHasChildren(hItem))
	{
		FILE_INFO* fi = (FILE_INFO*)m_LocalTreeCtrl.GetItemData(hItem);

		CString CurrentPath;
		CurrentPath.Format(_T("%s\\"), fi->strFileName);
		CString SearchPattern = CurrentPath + _T("*");
		CFileFind finder;
        BOOL bFound = finder.FindFile(SearchPattern);
		if (bFound)
		{
			while (bFound)
			{
                bFound = finder.FindNextFile();
                // skip . and .. files; otherwise, we'd
                // recur infinitely!
                if (finder.IsDots())
                    continue;

                if (finder.IsDirectory())
                {
				    HTREEITEM itm = m_LocalTreeCtrl.InsertItem(finder.GetFileName(), 2, 2, hItem);

				    FILE_INFO* fi = new FILE_INFO;
				    _tcscpy_s(fi->strFileName, CurrentPath+finder.GetFileName());
				    fi->bFolder = TRUE;
				    m_LocalTreeCtrl.SetItemData(itm, (DWORD_PTR)fi);
                }
			}

            finder.Close();
		}
	}
}

void CQTSHttpDemoDlg::OnItemexpandingLocalTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	
	HTREEITEM hItem = pNMTreeView->itemNew.hItem;//m_LocalTreeCtrl.GetSelectedItem();
	ExpandLocalTreeItem(hItem);

	*pResult = 0;
}


void CQTSHttpDemoDlg::OnDblclkLocalTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	HTREEITEM hItem = m_LocalTreeCtrl.GetSelectedItem();
    if (hItem)
    {
	    ExpandLocalTreeItem(hItem);
    }

	*pResult = 0;
}


void CQTSHttpDemoDlg::ExpandRemoteTreeItem(HTREEITEM hItem)
{
	if (!m_RemoteTreeCtrl.ItemHasChildren(hItem))
	{
		FILE_INFO* fi = (FILE_INFO*)m_RemoteTreeCtrl.GetItemData(hItem);

		CString NodeId;
		NodeId.Format(_T("%s"), fi->strFileName);
		BuildRemoteSubTree(hItem, NodeId);
	}
}

void CQTSHttpDemoDlg::OnItemexpandingRemoteTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	
	HTREEITEM hItem = pNMTreeView->itemNew.hItem;//m_RemoteTreeCtrl.GetSelectedItem();
	ExpandRemoteTreeItem(hItem);

	*pResult = 0;
}


void CQTSHttpDemoDlg::OnDblclkRemoteTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (!m_bIsLogin) return;

    LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

    HTREEITEM hItem = m_RemoteTreeCtrl.GetSelectedItem();
    if (hItem)
	    ExpandRemoteTreeItem(hItem);

	*pResult = 0;
}

void CQTSHttpDemoDlg::OnSelchangedRemoteTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (!m_bIsLogin) return;

	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	HTREEITEM hItem = pNMTreeView->itemNew.hItem;//m_RemoteTreeCtrl.GetSelectedItem();

	if (hItem != m_RemoteTreeCtrl.GetRootItem())
	{
		FILE_INFO* fi = (FILE_INFO*)m_RemoteTreeCtrl.GetItemData(hItem);
		LoadRemoteFileList(fi->strFileName);
	}
	else if (pNMTreeView->itemOld.hItem && pNMTreeView->itemOld.hItem != m_RemoteTreeCtrl.GetRootItem())
	{
		m_RemoteTreeCtrl.SelectItem(pNMTreeView->itemOld.hItem);
	}

	*pResult = 0;
}

void CQTSHttpDemoDlg::OnDblclkRemoteList(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (!m_bIsLogin) return;

	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	
	FILE_INFO* fi = (FILE_INFO*)m_RemoteListCtrl.GetItemData(pNMItemActivate->iItem);
	if (fi->bFolder)
	{
		//m_LocalListCtrl.DeleteAllItems();

		CString CurrentPath;
		CurrentPath.Format(_T("%s"), fi->strFileName);
		LoadRemoteFileList(CurrentPath);
	}

	*pResult = 0;
}

void CQTSHttpDemoDlg::SetProgress( int Progress )
{
    if (Progress == 100)
    {
        int i = 0;
    }
    m_Progress.QuadPart = Progress;
}
